$Satellite::DeployTime=10000;
$Satellite::LaserTime=3000;
$Satellite::RechargeTime=7000;
datablock ParticleData(GreenParticle)
{
	textureName          = "base/data/particles/dot";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = true;

	colors[0]	= "0 1 0 0.6";


	sizes[0]	= 0.75;

};
datablock ParticleData(RedParticle : GreenParticle)
{

	colors[0]	= "1 0 0 0.6";


	sizes[0]	= 1;

};
datablock ParticleEmitterData(SatLaserGreen)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 50.0;
   ejectionoffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 368640;
   phiVariance      = 0;
   overrideAdvance = false;
   useEmitterColors = false;

   particles = GreenParticle;   

	uiName = "Satellite Laser Green";
};
datablock ParticleEmitterData(SatLaserRed : SatLaserGreen)
{

   particles = RedParticle;   

	uiName = "Satellite Laser Red";
};

datablock StaticShapeData(LaserShape)
{
   shapeFile = "./laser.dts";
};
datablock StaticShapeData(SatelliteShape)
{
   shapeFile = "./satellite.dts";
};
datablock ItemData(SatelliteItem:printgun)
{
   uiname="Satellite Laser";
   colorShiftColor="0.2 0.3 0.6";
   doColorShift=true;
   image=SatelliteImage;
};
datablock ProjectileData(SatelliteProjectile)
{
   shapeFile="base/data/shapes/empty.dts";
   lifetime=1000;
   uiname="";
   showbricks=0;
};
datablock ShapeBaseImageData(SatelliteImage:PrintGunImage)
{
   item=SatelliteItem;
   showbricks=0;
   projectile=SatelliteProjectile;
   stateEmitter[2]=SatLaserGreen;
   colorShiftColor="0.2 0.3 0.6";
   doColorShift=true;
};
function drawLaser(%a,%b,%player) //Thanks port for most of the code in this function (I'm lazy, okay?)
{
   %offset = vectorSub( %a, %b );
	%normal = vectorNormalize( %offset );
   
	%xyz = vectorNormalize( vectorCross( "1 0 0", %normal ) );
	%pow = mRadToDeg( mACos( vectorDot( "1 0 0", %normal ) ) ) * -1;

	%obj = new staticShape()
	{
		datablock = laserShape;
		scale = vectorScale(vectorLen( %offset )@" 1 1",0.5);
      start = %a;
		position = vectorScale( vectorAdd( %a, %b ), 0.5 );
		rotation = %xyz SPC %pow;
	};

	missionCleanup.add( %obj );
	
	schedule($Satellite::LaserTime,0,vectorExplosions,%obj,%player);
	%obj.setNodeColor( "ALL", "0 1 0 1" );
	if(!isObject(SatelliteGroup))new SimGroup(SatelliteGroup);
	SatelliteGroup.add(%obj);
   return %obj;
}
function createSatellite(%p,%c)
{
   %s = new StaticShape()
   {
      datablock = SatelliteShape;
      scale = "1 1 1";
      position = %p;
      rotation = eulerToMatrix("");
      owner = %c;
   };
   if(!isObject(SatelliteGroup))new SimGroup(SatelliteGroup);
	SatelliteGroup.add(%s);
	%s.satelliteTick();
	return %s;
}
function SatelliteImage::onFire(%this,%obj,%slot)
{
   if(%this.deployTime+$Satellite::DeployTime>getSimTime())
   {
      if(isObject(%obj.client))
         %obj.client.chatmessage("\c5Your satellite hasn't finished deploying!");
      return;
   }
   if(%obj.lastLaser+$Satellite::LaserTime+$Satellite::RechargeTime<getSimTime())
   {
      parent::onFire(%this,%obj,%slot);
       %obj.spawnLaser();
   }
   else if(isObject(%obj.client))
      %obj.client.chatmessage("\c5You need to wait for your Satellite to finish charging!");
   if(!isObject(%obj.satellite))
   {
      %obj.SpawnSatellite();
      if(isObject(%obj.client))
      %obj.client.centerPrint("\c5Created a satellite",1);
   }
}
function StaticShape::satelliteTick(%this)
{
   cancel(%this.satSched);
   if(!isObject(%this.owner))
   {
      %this.delete();
      if(isObject(%this.laserShape))
         %this.laserShape.delete();
      return;
   }
   //if(%this.lastMove+2000<getSimTime())
      %this.moveTo(vectorAdd(%this.predict,%this.getSatPos(%this.tickCount++)));
   if(%this.owner.deployTime+$Satellite::DeployTime>getSimTime()&&isObject(%this.owner.client))
   {
      %this.owner.client.centerprint("<just:left>\c4Deploying Satellite \c2"@mRound(((getSimTime()-%this.owner.deployTime)/$Satellite::DeployTime)*100)@"\c4%",1);
   }
   else if(%time=%this.owner.lastLaser+$Satellite::LaserTime+$Satellite::RechargeTime>getSimTime()&&isObject(%this.owner.client))
   {
      if(%this.owner.lastLaser+$Satellite::LaserTime>getSimTime())
         %this.owner.client.centerprint("<just:left>\c4Firing Laser \c2"@mRound(((getSimTime()-%this.owner.lastLaser)/$Satellite::LaserTime)*100)@"\c4%",1);
      else
         %this.owner.client.centerprint("<just:left>\c4Re-Charging Satellite \c2"@mRound(((getSimTime()-%this.owner.lastLaser-$Satellite::LaserTime)/$Satellite::RechargeTime)*100)@"\c4%",1);
   }
   if(isObject(%l=%this.owner.laserShape))
   {
      %this.laserShape=%l;
      %pos=vectorScale( vectorAdd( %l.start, vectorSub(%this.getPosition(),"0 0 2") ), 0.5 );
      %l.setTransform(%pos SPC eulerToAxis(vectorAngle(vectorNormalize(vectorSub(%l.start, vectorSub(%this.getPosition(),"0 0 2") )))));
      %a=((getSimTime()-%this.owner.lastLaser)/3000);
      %l.setScale(vectorScale(vectorLen(vectorSub(%l.start, vectorSub(%this.getPosition(),"0 0 2"))) SPC 1-%a SPC 1-%a,0.5));
      %l.setNodeColor("ALL",%a SPC 1-%a @" 0 1");
   }
   %this.satSched=%this.schedule(16,satelliteTick);
}
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}
function StaticShape::moveTo(%this,%p)
{
   %this.setTransform(midPos(%this.getPosition(),%p,0.003) SPC eulerToAxis("0 0 "@%p*0.5));
}
function vectorAngle(%vector)
{
   return  0 SPC (mACos(getWord(%vector,2)/vectorDist("0 0 0",%vector))*(180/$pi)+90)%360 SPC
          mATan(getWord(%vector,1),getWord(%vector,0))*(180/$pi);
}
function StaticShape::getSatPos(%this,%a)
{
   %p=%this.owner;
   %z=200; //Z Offset
   %b=vectorAdd(%p.getPosition(),"0 0 "@%z);
   %f=0.001; //Revolution Speed
   %r=50; //Radius of Revolution
   %h=2; //Height of bouncing (Going up and down)
   %l=0.01; //Speed of bounging 
   %n=mCos(%a*%f)*%r SPC mSin(%a*%f)*%r SPC mSin(%a*%l)*%h;
   return vectorAdd(%b,%n);
}
function midPos(%a,%b,%s)
{
   %sub=vectorNormalize(vectorsub(%b,%a));
   %fraction = vectorDist(%b,%a)*%s;
   %vector=vectorScale(%sub,%fraction);
   %newpos=vectorAdd(%vector,%a);
   return %newpos;
}
function Player::SpawnSatellite(%this)
{
   if(isObject(%this.satellite))
      return;
   %s = createSatellite(vectorAdd(%this.getPosition(),"0 0 10"),%this);
   %s.setShapeName(%this.client.name@"'s Satellite");
   %this.deployTime=getSimTime();
   %this.satellite=%s;
}
function Player::SpawnLaser(%this)
{
   if(!isObject(%this.satellite))
      return;
   if(%this.lastLaser+$Satellite::LaserTime+$Satellite::RechargeTime>getSimTime())
      return;
   if(%this.deployTime+$Satellite::DeployTime>getSimTime())
      return;
   %obj=(%this.client.getControlObject());
   %this.lastLaser=getSimTime();
   %start = %obj.getEyePoint();
   %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
   %vec = %obj.getEyeVector();
   %end = vectorAdd(%start,vectorScale(%vec,500));
   %ray = containerRaycast(%start,%end,%targets,%obj);
   %col = firstWord(%ray);
   %pos = posFromRaycast(%ray);
   if(%pos == 0)
      %pos = vectorAdd(vectorScale(%obj.getEyeVector(), 500),%obj.getEyePoint());
   %pos = getWords(%pos,0,1) SPC "0";
   %l=drawLaser(%pos,vectorSub(%this.satellite.getPosition(),"0 0 2"),%this);
   //%l.schedule(2000,setNodeColor,"ALL","1 0 0 1");
   %l.schedule($Satellite::LaserTime,delete);
   %this.lasershape=%l;
   schedule($Satellite::LaserTime,0,spawnLaserExplosion,%this,%pos);
}
function spawnLaserExplosion(%player,%pos)
{
   if(!isObject(%player))
      return;
   %p = new Projectile()
   {
      datablock = tankShellProjectile;
      initialVelocity = "0 0 0";
      initialPosition = %pos;
      sourceObject = %player;
      sourceSlot = 0;
      client = %player.client;
   };
   %p.setScale("2 2 2");
   %p.explode();
}
function vectorExplosions(%obj,%player)
{
   //echo("shoot");
   if(!isObject(%obj)||!isObject(%player))
      return;
		
		// Range
		%start = %obj.start;
		//echo(%start);
		%vec = vectorSub(%obj.start,vectorSub(%player.satellite.getPosition(),"0 0 2"));
		%range		= vectorLen(%vec);
		//echo(%range);
		%aimvec = VectorScale(vectorNormalize(%vec),-1);
		%targets= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::staticShapeObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		// Raycast Parameters
		%end[0]		= vectorAdd(%start, vectorScale(%aimvec, %range)); // [0] required for loop
		//echo(%end0);
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0],%targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
         spawnLaserExplosion(%player,%pos);			
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
      for(%a = 1; %a <= %range; %a++)
      {
         
         %start[%a]	= %end[%a - 1];
         %end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
         
         %ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
         %col		= getWord(%ray, 0);
         if(isObject(%col))
         {
            %pos		= posFromRaycast(%ray);
            %normal		= normalFromRaycast(%ray);
            %end[%a]	= %pos;
            %colclass	= %col.getClassName();
            %objsHit++;
            
            spawnLaserExplosion(%player,%pos);
            //echo("Boom "@%objsHit SPC %col);
            if(%colclass $= "Player" || %colclass $= "AIPlayer")
            {
               if(%col.getState() $= "Dead")
               {
                  %objsKilled++;
               }
            }
         }
		}
}
if(isPackage(Satellite))
   deactivatepackage(Satellite);
package Satellite
{
   function servercmdshiftBrick(%c,%a,%b,%k)
   {
      //if(!isObject(%p=%c.player))
         return parent::servercmdshiftBrick(%c,%a,%b,%k);
      if(!isObject(%s=%p.satellite))
         return parent::servercmdshiftBrick(%c,%a,%b,%k);
      if(%c.getControlObject()==%c.camera)
      {
         %r=%s.predict;
         %s.predict="0 0 0";//(vectorAdd(%r,%a SPC %b SPC 0));
         %s.lastMove=getSimTime();
         %s.setTransform(vectorAdd(%s.getTransform(),%a SPC %b));
      }
   }
   function servercmdLight(%c)
   {
      if(!isObject(%p=%c.player))
         return parent::servercmdLight(%c);
      if(!isObject(%s=%p.satellite))
         return parent::servercmdLight(%c);
      if(%c.getControlObject()==%c.camera)
      {
         %c.setControlObject(%p);
         commandtoClient(%c,setBuildingDisabled,(isObject(%c.minigame)));
      }
      else if(%c.getControlObject()==%p)
      {
         %m=%c.camera;
         %m.setFlyMode();
         %m.mode = "Observer";

         %m.setTransform(%s.getTransform());

         %c.setControlObject(%m);
         %m.setControlObject(%p);
         commandtoClient(%c,setBuildingDisabled,0);
         //%d=(isObject(%p.laserShape)?vectorAdd(vectorAngle(vectorSub(%p.laserShape.start,%s.getPosition())),"0 0 0"):"270 0 0");
         %d="270 0 0";
         %m.setOrbitMode(%s, %m.getPosition() SPC eulerToAxis(%d), 3.5, 0, 0, 0);
      }
   }
};
activatepackage(Satellite); 
function mRound(%a)
{
   return (%a-mFloor(%a)>=0.5?mCeil(%a):mFloor(%a));
}